
<?php
session_start();

const DASHBOARD_USER = 'admin';
const DASHBOARD_PASSWORD = 'changeMe123!';

if (isset($_GET['logout'])) {
    session_destroy();
    header("Location: " . $_SERVER['PHP_SELF']);
    exit;
}

if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['dashboard_user'], $_POST['dashboard_password'])) {
    if ($_POST['dashboard_user'] === DASHBOARD_USER && $_POST['dashboard_password'] === DASHBOARD_PASSWORD) {
        $_SESSION['dashboard_auth'] = true;
        header("Location: " . $_SERVER['PHP_SELF']);
        exit;
    } else {
        $error = "Benutzername oder Passwort falsch!";
    }
}

if (!isset($_SESSION['dashboard_auth']) || $_SESSION['dashboard_auth'] !== true): ?>
<!DOCTYPE html>
<html lang="de">
<head>
  <meta charset="UTF-8">
  <title>Login</title>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.0/css/all.min.css">
  <style>
    body { font-family: sans-serif; background: #e0eafc; height: 100vh; display: flex; align-items: center; justify-content: center; flex-direction: column; }
    form { background: white; padding: 30px; border-radius: 12px; box-shadow: 0 0 15px rgba(0,0,0,0.1); width: 100%; max-width: 400px; }
    input { padding: 10px; margin-bottom: 15px; width: 100%; border-radius: 6px; border: 1px solid #ccc; }
    button { padding: 10px; width: 100%; background: #007bff; color: white; border: none; border-radius: 6px; cursor: pointer; }
    .error { color: red; font-weight: bold; margin-bottom: 10px; }
    .download-link, footer { margin-top: 20px; text-align: center; font-size: 0.95em; color: #777; }
    .download-link a, footer a { color: #007bff; text-decoration: none; font-weight: bold; }
    .download-link a:hover, footer a:hover { text-decoration: underline; }
  </style>
</head>
<body>
<form method="POST">
  <h2>🔒 Dashboard Login</h2>
  <?php if (isset($error)): ?><div class="error"><?php echo $error; ?></div><?php endif; ?>
  <input type="text" name="dashboard_user" placeholder="Benutzername" required>
  <input type="password" name="dashboard_password" placeholder="Passwort" required>
  <button type="submit">Einloggen</button>
</form>
<div class="download-link">
  <p><i class="fa-solid fa-globe"></i> <a href="https://rustdesk.com" target="_blank">Offizielle RustDesk Website</a></p>
  <p><i class="fa-solid fa-download"></i> <a href="https://github.com/rustdesk/rustdesk/releases" target="_blank">RustDesk Downloadseite (GitHub)</a></p>
</div>
<footer>
  &copy; <?php echo date('Y'); ?> Daniel Mattick – <a href="https://matdan.de" target="_blank">matdan.de</a> | <a href="https://portfolio.matdan.de" target="_blank">portfolio.matdan.de</a>
</footer>
</body>
</html>
<?php exit; endif;

// ab hier folgt das Interface wie gehabt...

function getServerIP() {
    return $_SERVER['SERVER_ADDR'] ?? gethostbyname(gethostname());
}

function getPublicKey() {
    $keyFile = '/var/lib/rustdesk-server/id_ed25519.pub';
    return file_exists($keyFile) ? trim(file_get_contents($keyFile)) : 'Schlüssel nicht gefunden';
}

function getLogEntries($file, $limit = 10) {
    if (!file_exists($file)) return ['Keine Logdatei gefunden'];
    $lines = file($file, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
    return array_slice(array_reverse($lines), 0, $limit);
}

function parseJsonField($jsonStr) {
    $decoded = json_decode($jsonStr, true);
    $ip = $decoded['ip'] ?? '';
    return str_replace('::ffff:', '', $ip);
}

function getOnlinePeers() {
    $hbbr = '/var/log/rustdesk-server/hbbr.log';
    if (!file_exists($hbbr)) return [];
    $lines = file($hbbr, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
    $online = [];
    $now = time();
    foreach (array_reverse($lines) as $line) {
        if (strpos($line, 'got paired') !== false && preg_match('/\[::ffff:(.*?)\]/', $line, $match)) {
            $ip = $match[1];
            $timestamp = strtotime(substr($line, 1, 25));
            if ($timestamp && ($now - $timestamp < 300)) {
                $online[] = $ip;
            }
        }
    }
    return array_unique($online);
}

function getClientDataFromDB($dbFile, $aliasFile = 'client-aliases.json') {
    $clients = [];
    $aliases = file_exists($aliasFile) ? json_decode(file_get_contents($aliasFile), true) ?? [] : [];
    $onlineIps = getOnlinePeers();
    try {
        $pdo = new PDO("sqlite:$dbFile");
        $query = $pdo->query("SELECT * FROM peer ORDER BY created_at DESC");
        while ($row = $query->fetch(PDO::FETCH_ASSOC)) {
            $ip = parseJsonField($row['info']);
            $created = strtotime($row['created_at']);
            $clients[] = [
                'id' => $row['id'],
                'uuid' => bin2hex($row['uuid']),
                'created_at' => $row['created_at'],
                'created_diff' => time() - $created,
                'alias' => $aliases[$row['id']] ?? '',
                'note' => $row['note'] ?? '',
                'last_ip' => $ip,
                'online' => in_array($ip, $onlineIps)
            ];
        }
    } catch (PDOException $e) {
        $clients[] = ['id' => 'Fehler beim Zugriff auf DB: ' . $e->getMessage()];
    }
    return $clients;
}

if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['aliases'], $_POST['notes'])) {
    $aliases = array_map('trim', $_POST['aliases']);
    file_put_contents('client-aliases.json', json_encode($aliases, JSON_PRETTY_PRINT));

    try {
        $pdo = new PDO("sqlite:/var/lib/rustdesk-server/db_v2.sqlite3");
        foreach ($_POST['notes'] as $id => $note) {
            $stmt = $pdo->prepare("UPDATE peer SET note = :note WHERE id = :id");
            $stmt->execute([':note' => trim($note), ':id' => $id]);
        }
    } catch (PDOException $e) {
        echo "<div style='color:red'>Fehler beim Speichern der Notizen: " . htmlspecialchars($e->getMessage()) . "</div>";
    }
    header("Location: " . $_SERVER['PHP_SELF']);
    exit;
}

$logFile = '/var/log/rustdesk-server/hbbr.log';
$logEntries = getLogEntries($logFile);
$clients = getClientDataFromDB('/var/lib/rustdesk-server/db_v2.sqlite3');

function formatTimeAgo($seconds) {
    if ($seconds < 60) return "$seconds Sekunden";
    if ($seconds < 3600) return round($seconds/60) . " Minuten";
    if ($seconds < 86400) return round($seconds/3600) . " Stunden";
    return round($seconds/86400) . " Tage";
}
?>
<!DOCTYPE html>
<html lang="de">
<head>
  <meta charset="UTF-8">
  <title>RustDesk Admin Interface</title>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.0/css/all.min.css">
  <style>
    body { font-family: 'Segoe UI', sans-serif; background: linear-gradient(to right, #e0eafc, #cfdef3); margin: 0; padding: 30px; display: flex; flex-direction: column; min-height: 100vh; }
    .container { max-width: 1000px; margin: auto; background: #fff; border-radius: 16px; box-shadow: 0 8px 24px rgba(0, 0, 0, 0.1); padding: 30px; flex-grow: 1; }
    h1 { text-align: center; margin-bottom: 30px; }
    .top-links { display: flex; justify-content: space-between; margin-bottom: 20px; }
    .top-links a { text-decoration: none; padding: 8px 12px; border-radius: 6px; font-weight: bold; color: white; }
    .logout { background: #dc3545; } .logout:hover { background: #a71d2a; }
    .downloads { background: #007bff; } .downloads:hover { background: #0056b3; }
    .section { margin-bottom: 40px; }
    .section h2 { font-size: 1.4em; margin-bottom: 15px; border-left: 5px solid #007bff; padding-left: 10px; color: #333; }
    .log-entry, .client-entry { background: #f0f4f8; padding: 15px; margin: 10px 0; border-radius: 10px; font-family: monospace; }
    .client-entry.online i { color: green; } .client-entry.offline i { color: red; }
    .timestamp { font-size: 0.8em; color: #888; }
    input, textarea { padding: 6px; margin-top: 6px; width: 100%; border-radius: 6px; border: 1px solid #ccc; font-family: monospace; }
    .submit-btn { margin-top: 20px; padding: 10px 15px; background: #28a745; border: none; color: white; border-radius: 6px; cursor: pointer; font-weight: bold; }
    .submit-btn:hover { background: #218838; }
    .client-meta { font-size: 0.9em; color: #333; margin-top: 5px; }
    footer { text-align: center; font-size: 0.9em; color: #777; margin-top: 30px; }
  </style>
</head>
<body>
<div class="container">
  <div class="top-links">
    <a href="https://rustdesk.com" class="downloads" target="_blank"><i class="fa-solid fa-globe"></i> RustDesk Website</a>
    <a href="https://github.com/rustdesk/rustdesk/releases" class="downloads" target="_blank"><i class="fa-solid fa-download"></i> RustDesk Downloads</a>
    <a href="?logout=1" class="logout"><i class="fa-solid fa-door-open"></i> Logout</a>
  </div>

  <h1><i class="fa-solid fa-network-wired"></i> RustDesk Server Übersicht</h1>

  <div class="section">
    <h2><i class="fa-solid fa-server"></i> Server IP-Adresse</h2>
    <div class="client-entry"><i class="fa-solid fa-globe"></i> <?php echo getServerIP(); ?></div>
  </div>

  <div class="section">
    <h2><i class="fa-solid fa-key"></i> Öffentlicher Schlüssel</h2>
    <div class="client-entry"><i class="fa-solid fa-lock"></i> <?php echo getPublicKey(); ?></div>
  </div>

  <div class="section">
    <h2><i class="fa-solid fa-clipboard-list"></i> Letzte Log-Einträge</h2>
    <?php foreach ($logEntries as $entry): ?>
      <div class="log-entry"><i class="fa-solid fa-file-lines"></i> <?php echo htmlspecialchars($entry); ?></div>
    <?php endforeach; ?>
  </div>

  <div class="section">
    <h2><i class="fa-solid fa-users"></i> Bekannte Clients</h2>
    <form method="POST">
      <?php foreach ($clients as $client): ?>
        <div class="client-entry <?php echo $client['online'] ? 'online' : 'offline'; ?>">
          <strong>ID:</strong> <?php echo htmlspecialchars($client['id']); ?>
          <?php if ($client['alias']): ?> (<?php echo htmlspecialchars($client['alias']); ?>)<?php endif; ?>
          – <i class="fa-solid fa-circle"></i> <strong><?php echo $client['online'] ? 'Online' : 'Offline'; ?></strong>
          <br><strong>UUID:</strong> <?php echo $client['uuid']; ?>
          <br><strong>Letzte bekannte IP:</strong> <?php echo $client['last_ip']; ?>
          <br><strong>Erstellt:</strong> <?php echo $client['created_at']; ?> (vor <?php echo formatTimeAgo($client['created_diff']); ?>)
          <br>
          <label>Alias: <input type="text" name="aliases[<?php echo htmlspecialchars($client['id']); ?>]" value="<?php echo htmlspecialchars($client['alias']); ?>"></label>
          <br>
          <label>Notiz: <textarea name="notes[<?php echo htmlspecialchars($client['id']); ?>]"><?php echo htmlspecialchars($client['note']); ?></textarea></label>
        </div>
      <?php endforeach; ?>
      <button type="submit" class="submit-btn"><i class="fa-solid fa-save"></i> Änderungen speichern</button>
    </form>
  </div>
</div>
<footer>
  &copy; <?php echo date('Y'); ?> Daniel Mattick – <a href="https://matdan.de" target="_blank">matdan.de</a> | <a href="https://portfolio.matdan.de" target="_blank">portfolio.matdan.de</a>
</footer>
</body>
</html>
